import cmdlib
import es

def load():
	load_module_server_cmd()
	es.server.cmd("exec soccer_mod/modules.cfg")

def load_module_server_cmd():
	cmdlib.registerServerCommand("soccer_mod_module_cap", module_cap, "Load the cap module")
	cmdlib.registerServerCommand("soccer_mod_module_match", module_match, "Load the match module")
	cmdlib.registerServerCommand("soccer_mod_module_match_stats", module_match_stats, "Load the match module")
	cmdlib.registerServerCommand("soccer_mod_module_match_subs", module_match_subs, "Load the match module")
	cmdlib.registerServerCommand("soccer_mod_module_player", module_player, "Load the player module")
	cmdlib.registerServerCommand("soccer_mod_module_referee", module_referee, "Load the referee module")
	cmdlib.registerServerCommand("soccer_mod_module_referee_punish", module_referee_punish, "Load the referee module")
	cmdlib.registerServerCommand("soccer_mod_module_referee_warn", module_referee_warn, "Load the referee module")
	cmdlib.registerServerCommand("soccer_mod_module_shout", module_shout, "Load the shout module")
	cmdlib.registerServerCommand("soccer_mod_module_sprint", module_sprint, "Load the sprint module")
	cmdlib.registerServerCommand("soccer_mod_module_training", module_training, "Load the training module")

def module_cap(args):
	set_module_value("sm_module_cap_on", args[0])

def module_match(args):
	set_module_value("sm_module_match_on", args[0])

def module_match_stats(args):
	set_module_value("sm_module_match_stats_on", args[0])

def module_match_subs(args):
	set_module_value("sm_module_match_subs_on", args[0])

def module_player(args):
	set_module_value("sm_module_player_on", args[0])

def module_referee(args):
	set_module_value("sm_module_referee_on", args[0])

def module_referee_punish(args):
	set_module_value("sm_module_referee_punish_on", args[0])

def module_referee_warn(args):
	set_module_value("sm_module_referee_warn_on", args[0])

def module_shout(args):
	set_module_value("sm_module_shout_on", args[0])

def module_sprint(args):
	set_module_value("sm_module_sprint_on", args[0])

def module_training(args):
	set_module_value("sm_module_training_on", args[0])

def set_module_value(name, value):
	try:
		check = int(value)
		if check == 1:
			es.set(name, 1)
		else:
			es.set(name, 0)
	except ValueError:
		es.set(name, 0)

def unload_module_server_cmd():
	cmdlib.unregisterServerCommand("soccer_mod_module_cap")
	cmdlib.unregisterServerCommand("soccer_mod_module_match")
	cmdlib.unregisterServerCommand("soccer_mod_module_match_stats")
	cmdlib.unregisterServerCommand("soccer_mod_module_match_subs")
	cmdlib.unregisterServerCommand("soccer_mod_module_player")
	cmdlib.unregisterServerCommand("soccer_mod_module_referee")
	cmdlib.unregisterServerCommand("soccer_mod_module_referee_punish")
	cmdlib.unregisterServerCommand("soccer_mod_module_referee_warn")
	cmdlib.unregisterServerCommand("soccer_mod_module_shout")
	cmdlib.unregisterServerCommand("soccer_mod_module_sprint")
	cmdlib.unregisterServerCommand("soccer_mod_module_training")

def unload():
	unload_module_server_cmd()