import es
import gamethread
import keymenulib
import langlib
import popuplib

# ******************** Load ********************
def load():
	create_popup()

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/admin/popup_admin_manager.ini")

	popup = popuplib.create("sm_popup_admin_manager")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("add map"))
	popup.addline(line)

	line = "->2. %s" % (text("remove map"))
	popup.addline(line)

	line = "->3. %s" % (text("add admin"))
	popup.addline(line)

	line = "->4. %s" % (text("edit admin"))
	popup.addline(line)

	line = "->5. %s" % (text("remove admin"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, select_add_map)
	popup.select(2, select_remove_map)
	popup.select(3, select_add_admin)
	popup.select(4, select_edit_admin)
	popup.select(5, select_remove_admin)
	popup.submenu(6, "sm_popup_admin_manager")
	popup.submenu(7, "sm_popup_admin_manager")
	popup.submenu(8, "sm_popup_admin_manager")
	popup.submenu(9, "sm_popup_admin")

# ******************** Events ********************
def player_say(event_var):
	steamid = es.getplayersteamid(event_var["userid"])

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "manager_map_add":
			add_map(event_var["text"], event_var["userid"], steamid)
		elif type == "manager_admin_add_name":
			add_admin_name(event_var["text"], event_var["userid"], steamid)
		elif type == "manager_admin_add_steamid":
			add_admin_steamid(event_var["text"], event_var["userid"], steamid)

# ******************** Add map ********************
def select_add_map(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "manager_map_add")

	es.tell(userid, "#green", "Type the name of the map you want to add in the chat or type !cancel to cancel.")

def add_map(text, userid, steamid):
	if text != "!cancel":
		exists = es.exists("key", "soccer_mod_maps", text)
		if exists == 0:
			exists = es.exists("map", text)
			if exists == 1:
				es.keycreate("soccer_mod_maps", text)
				es.keysetvalue("soccer_mod_maps", text, "soccer_mod", 1)

				cmd = "keygroupsort soccer_mod_maps soccer_mod_maps asc #alpha"
				es.server.cmd(cmd)
				es.keygroupsave("soccer_mod_maps", "soccer_mod")

				message = "Map %s has been added." % (text)
				es.tell(userid, "#green", message)

				current_map = es.ServerVar("eventscripts_currentmap")
				if current_map == text:
					enabled = es.ServerVar("soccer_mod_allowed")
					if enabled == 0:
						es.msg("#green", "Map will restart in 3 seconds.")

						gamethread.delayed(3, reload_map, (text))
			else:
				message = "Map %s does not exist on this server." % (text)
				es.tell(userid, "#green", message)
		else:
			message = "Map %s is already added to the map list." % (text)
			es.tell(userid, "#green", message)

	clear_key(userid, steamid)

def reload_map(name):
	cmd = "changelevel %s" % (name)
	es.server.queuecmd(cmd)

# ******************** Remove map ********************
def select_remove_map(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	keymenu = keymenulib.create(name, "target", remove_map, "soccer_mod_maps", "#key", "#key", "Remove a map")
	keymenu.backmenu("sm_popup_admin_manager")
	keymenulib.send(name, userid)

def remove_map(userid, choice, keymenuname):
	exists = es.exists("key", "soccer_mod_maps", choice)
	if exists == 1:
		es.keydelete("soccer_mod_maps", choice)
		es.keygroupsave("soccer_mod_maps", "soccer_mod")

		message = "Map %s has been removed from the allowed maps list." % (choice)
		es.tell(userid, "#green", message)
	else:
		message = "Map %s does not exist." % (choice)
		es.tell(userid, "#green", message)

	popuplib.send("sm_popup_admin_manager", userid)

# ******************** Add admin ********************
def select_add_admin(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "manager_admin_add_name")

	es.tell(userid, "#green", "Type the name of the admin you want to add in the chat or type !cancel to cancel.")

def add_admin_name(text, userid, steamid):
	if text != "!cancel":
		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "manager_admin_add_steamid")
		es.keysetvalue("sm_keygroup_set", steamid, "name", text)

		message = "Now type the steamid of the admin in the chat or type !cancel to cancel."
		es.tell(userid, "#green", message)
	else:
		clear_key(userid, steamid)

def add_admin_steamid(text, userid, steamid):
	if text != "!cancel":
		name = es.keygetvalue("sm_keygroup_set", steamid, "name")

		exists = es.exists("key", "soccer_mod_admins", text)
		if exists == 0:
			es.keycreate("soccer_mod_admins", text)
			es.keysetvalue("soccer_mod_admins", text, "name", name)
			es.keysetvalue("soccer_mod_admins", text, "match", 0)
			es.keysetvalue("soccer_mod_admins", text, "cap", 0)
			es.keysetvalue("soccer_mod_admins", text, "referee", 0)
			es.keysetvalue("soccer_mod_admins", text, "training", 0)
			es.keysetvalue("soccer_mod_admins", text, "settings", 0)
			es.keysetvalue("soccer_mod_admins", text, "manager", 0)

			cmd = "keygroupsort soccer_mod_admins name asc #alpha"
			es.server.cmd(cmd)
			es.keygroupsave("soccer_mod_admins", "soccer_mod")

			message = "Admin %s has been added." % (name)
			es.tell(userid, "#green", message)

			es.keysetvalue("sm_keygroup_set", steamid, "edit", text)
			name = "sm_popup_%s" % (userid)
			create_popup_edit(name, text)
			popuplib.send(name, userid)
		else:
			message = "Steamid of admin %s already exists." % (name)
			es.tell(userid, "#green", message)
			clear_key(userid, steamid)

# ******************** Edit admin ********************
def select_edit_admin(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	keymenu = keymenulib.create(name, "target", edit_admin, "soccer_mod_admins", "#keyvalue name", "#key", "Edit an admin")
	keymenu.backmenu("sm_popup_admin_manager")
	keymenulib.send(name, userid)

def edit_admin(userid, choice, keymenuname):
	exists = es.exists("key", "soccer_mod_admins", choice)
	if exists == 1:
		steamid = es.getplayersteamid(userid)

		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "edit", choice)

		name = "sm_popup_%s" % (userid)
		create_popup_edit(name, choice)
		popuplib.send(name, userid)
	else:
		message = "Admin %s does not exist." % (choice)
		es.tell(userid, "#green", message)
		popuplib.send("sm_popup_admin_manager", userid)

def create_popup_edit(name, steamid):
	if popuplib.exists(name):
		popuplib.delete(name)

	popup = popuplib.create(name)
	popup.addline("SOCCER MOD MANAGER EDIT ADMIN")
	popup.addline(" ")

	value = es.keygetvalue("soccer_mod_admins", steamid, "name")
	line = "->1. Name: %s" % (value)
	popup.addline(line)

	line = "->2. Steamid: %s" % (steamid)
	popup.addline(line)

	value = int(es.keygetvalue("soccer_mod_admins", steamid, "match"))
	if value == 1:
		line = "->3. Match access: yes"
	else:
		line = "->3. Match access: no"
	popup.addline(line)

	value = int(es.keygetvalue("soccer_mod_admins", steamid, "cap"))
	if value == 1:
		line = "->4. Cap access: yes"
	else:
		line = "->4. Cap access: no"
	popup.addline(line)

	value = int(es.keygetvalue("soccer_mod_admins", steamid, "referee"))
	if value == 1:
		line = "->5. Referee access: yes"
	else:
		line = "->5. Referee access: no"
	popup.addline(line)

	value = int(es.keygetvalue("soccer_mod_admins", steamid, "training"))
	if value == 1:
		line = "->6. Training access: yes"
	else:
		line = "->6. Training access: no"
	popup.addline(line)

	value = int(es.keygetvalue("soccer_mod_admins", steamid, "settings"))
	if value == 1:
		line = "->7. Settings access: yes"
	else:
		line = "->7. Settings access: no"
	popup.addline(line)

	value = int(es.keygetvalue("soccer_mod_admins", steamid, "manager"))
	if value == 1:
		line = "->8. Manager access: yes"
	else:
		line = "->8. Manager access: no"
	popup.addline(line)

	popup.addline(" ")
	popup.addline("->9. Back")
	popup.addline(" ")
	popup.addline("0. Close")

	popup.select(1, edit_admin_name)
	popup.select(2, edit_admin_steamid)
	popup.select(3, edit_admin_access)
	popup.select(4, edit_admin_access)
	popup.select(5, edit_admin_access)
	popup.select(6, edit_admin_access)
	popup.select(7, edit_admin_access)
	popup.select(8, edit_admin_access)
	popup.submenu(9, "sm_popup_admin_manager")

def edit_admin_name(userid, choice, popupid):
	user_steamid = es.getplayersteamid(userid)

	steamid = es.keygetvalue("sm_keygroup_set", user_steamid, "edit")

	name = "sm_popup_%s" % (userid)
	create_popup_edit(name, steamid)
	popuplib.send(name, userid)

def edit_admin_steamid(userid, choice, popupid):
	user_steamid = es.getplayersteamid(userid)

	steamid = es.keygetvalue("sm_keygroup_set", user_steamid, "edit")

	name = "sm_popup_%s" % (userid)
	create_popup_edit(name, steamid)
	popuplib.send(name, userid)

def edit_admin_access(userid, choice, popupid):
	user_steamid = es.getplayersteamid(userid)

	steamid = es.keygetvalue("sm_keygroup_set", user_steamid, "edit")
	if choice == 3:
		value = int(es.keygetvalue("soccer_mod_admins", steamid, "match"))
		if value == 1:
			es.keysetvalue("soccer_mod_admins", steamid, "match", 0)
		else:
			es.keysetvalue("soccer_mod_admins", steamid, "match", 1)
	elif choice == 4:
		value = int(es.keygetvalue("soccer_mod_admins", steamid, "cap"))
		if value == 1:
			es.keysetvalue("soccer_mod_admins", steamid, "cap", 0)
		else:
			es.keysetvalue("soccer_mod_admins", steamid, "cap", 1)
	elif choice == 5:
		value = int(es.keygetvalue("soccer_mod_admins", steamid, "referee"))
		if value == 1:
			es.keysetvalue("soccer_mod_admins", steamid, "referee", 0)
		else:
			es.keysetvalue("soccer_mod_admins", steamid, "referee", 1)
	elif choice == 6:
		value = int(es.keygetvalue("soccer_mod_admins", steamid, "training"))
		if value == 1:
			es.keysetvalue("soccer_mod_admins", steamid, "training", 0)
		else:
			es.keysetvalue("soccer_mod_admins", steamid, "training", 1)
	elif choice == 7:
		value = int(es.keygetvalue("soccer_mod_admins", steamid, "settings"))
		if value == 1:
			es.keysetvalue("soccer_mod_admins", steamid, "settings", 0)
		else:
			es.keysetvalue("soccer_mod_admins", steamid, "settings", 1)
	elif choice == 8:
		value = int(es.keygetvalue("soccer_mod_admins", steamid, "manager"))
		if value == 1:
			es.keysetvalue("soccer_mod_admins", steamid, "manager", 0)
		else:
			es.keysetvalue("soccer_mod_admins", steamid, "manager", 1)

	es.keygroupsave("soccer_mod_admins", "soccer_mod")

	name = "sm_popup_%s" % (userid)
	create_popup_edit(name, steamid)
	popuplib.send(name, userid)

# ******************** Remove admin ********************
def select_remove_admin(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	keymenu = keymenulib.create(name, "target", remove_admin, "soccer_mod_admins", "#keyvalue name", "#key", "Remove an admin")
	keymenu.backmenu("sm_popup_admin_manager")
	keymenulib.send(name, userid)

def remove_admin(userid, choice, keymenuname):
	exists = es.exists("key", "soccer_mod_admins", choice)
	if exists == 1:
		es.keydelete("soccer_mod_admins", choice)
		es.keygroupsave("soccer_mod_admins", "soccer_mod")

		message = "Admin %s has been removed." % (choice)
		es.tell(userid, "#green", message)
	else:
		message = "Admin %s does not exist." % (choice)
		es.tell(userid, "#green", message)

	popuplib.send("sm_popup_admin_manager", userid)

# ******************** Functions ********************
def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_manager", userid)

def delete_popup(name):
	if popuplib.exists(name):
		popuplib.delete(name)

# ******************** Unload ********************
def unload():
	delete_popup("sm_popup_admin_manager")