import es
import gamethread
import langlib
import math
import playerlib
import popuplib
import random

def load():
	load_variables()
	create_popup()

	es.load("soccer_mod_2010/match/names")
	es.load("soccer_mod_2010/match/score")
	es.load("soccer_mod_2010/match/time")

	check = es.ServerVar("sm_module_match_stats_on")
	if check == 1:
		es.load("soccer_mod_2010/match/stats")

def load_variables():
	es.set("match", 0)
	es.set("match_paused", 0)
	es.set("period", 0)
	es.set("period_time", 0)
	es.set("minutes", 0)
	es.set("seconds", 0)
	es.set("period_running", 0)
	es.set("period_break_running", 0)
	es.set("golden_goal", 0)
	es.set("match_toss", 0)

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_admin_match.ini")

	popup = popuplib.create("sm_popup_admin_match")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("start"))
	popup.addline(line)

	line = "->2. %s" % (text("pause"))
	popup.addline(line)

	line = "->3. %s" % (text("unpause"))
	popup.addline(line)

	line = "->4. %s" % (text("stop"))
	popup.addline(line)

	line = "->5. %s" % (text("names"))
	popup.addline(line)

	line = "->6. %s" % (text("score"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, popup_match_start)
	popup.select(2, popup_match_pause)
	popup.select(3, popup_match_unpause)
	popup.select(4, popup_match_stop)
	popup.submenu(5, "sm_popup_admin_match_names")
	popup.submenu(6, "sm_popup_admin_match_score")
	popup.submenu(7, "sm_popup_admin_match")
	popup.submenu(8, "sm_popup_admin_match")
	popup.submenu(9, "sm_popup_admin")

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		match_paused = es.ServerVar("match_paused")
		period_break_running = es.ServerVar("period_break_running")
		if match_paused == 1 or period_break_running == 1:
			freeze_match()
		else:
			unfreeze_match()

		check = es.ServerVar("sm_match_sounds_on")
		if check == 1:
			sound = es.ServerVar("sm_match_sound_round_start")
			es.cexec_all("playgamesound", sound)

def round_end(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("sm_match_sounds_on")
		if check == 1:
			sound = es.ServerVar("sm_match_sound_round_end")
			es.cexec_all("playgamesound", sound)

def cmd_match_start():
	userid = es.getcmduserid()

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("sm_match_say_command_start_match_on")
		if check == 1:
			start_match_check(userid)
		else:
			es.tell(userid, "#green", "Start match command is turned off.")
	else:
		es.tell(userid, "#green", "Soccer Mod is not allowed on this map.")

def popup_match_start(userid, choice, popupid):
	start_match_check(userid)
	popuplib.send("sm_popup_admin_match", userid)

def start_match_check(userid):
	check = es.ServerVar("cap_fight")
	if check == 0:
		check = es.ServerVar("sm_training_cannon_on")
		if check == 0:
			check = es.ServerVar("sm_training_goals_disabled")
			if check == 0:
				check = es.ServerVar("match")
				if check == 0:
					exists = es.exists("keygroup", "sm_keygroup_vote")
					if exists == 0:
						name = es.getplayername(userid)

						check = es.ServerVar("sm_match_ready_vote_on")
						if check == 1:
							message = "%s has started a ready vote." % (name)
							es.msg("#green", message)

							es.set("sm_vote_question", "Are you ready to play a match?")
							es.set("sm_vote_all", 0)
							es.set("sm_vote_block", "soccer_mod_2010/match/start_match")

							es.doblock("soccer_mod_2010/vote/start")
						else:
							message = "%s has started a match." % (name)
							es.msg("#green", message)

							start_match()
					else:
						es.tell(userid, "#green", "A vote is still active.")
				else:
					es.tell(userid, "#green", "Match already started.")
			else:
				es.tell(userid, "#green", "You can not start a match when the goals are disabled.")
		else:
			es.tell(userid, "#green", "You can not start a match when the ball cannon is on.")
	else:
		es.tell(userid, "#green", "You can not start a match during a cap fight.")

def start_match():
	es.set("match", 1)
	es.set("match_paused", 0)
	es.set("period", 1)
	es.set("period_time", 1)
	es.set("minutes", 0)
	es.set("seconds", 0)
	es.set("period_running", 0)
	es.set("period_break_running", 0)
	es.set("sm_match_score_t", 0)
	es.set("sm_match_score_ct", 0)
	es.set("sm_match_subs_t", 0)
	es.set("sm_match_subs_ct", 0)
	es.set("golden_goal", 0)
	es.set("sm_match_first_hit", 1)

	es.keygroupdelete("soccer_mod_stats")
	es.keygroupcreate("soccer_mod_stats")
	es.doblock("soccer_mod_2010/match/stats/reset_team_stats")

	number = random.randint(0, 1)
	es.set("match_toss", number)

	periods = int(es.ServerVar("sm_match_number_periods"))
	if periods < 3:
		es.set("score_board_period", "Half time")
	else:
		es.set("score_board_period", "Period break")

	check = es.ServerVar("sm_match_swap_home_away_on")
	name_t = es.ServerVar("sm_match_name_t")
	name_ct = es.ServerVar("sm_match_name_ct")
	if check == 0:
		message = "%s - %s" % (name_t, name_ct)
	else:
		message = "%s - %s" % (name_ct, name_t)
	es.msg("#green", message)

	period_length = int(es.ServerVar("sm_match_period_length"))
	match_length = periods * period_length

	match_minutes = int(math.floor(match_length / 60))
	match_seconds = int(match_length - (match_minutes * 60))

	period_break_length = int(es.ServerVar("sm_match_period_break_length"))

	match_break_minutes = int(math.floor(period_break_length / 60))
	match_break_seconds = int(period_break_length - (match_break_minutes * 60))

	if match_seconds < 10:
		if match_break_seconds < 10:
			message = "This match will take %s:0%s over %s period(s). The period break(s) will take %s:0%s." % (match_minutes, match_seconds, periods, match_break_minutes, match_break_seconds)
		else:
			message = "This match will take %s:0%s over %s period(s). The period break(s) will take %s:%s." % (match_minutes, match_seconds, periods, match_break_minutes, match_break_seconds)
	else:
		if match_break_seconds < 10:
			message = "This match will take %s:%s over %s period(s). The period break(s) will take %s:0%s." % (match_minutes, match_seconds, periods, match_break_minutes, match_break_seconds)
		else:
			message = "This match will take %s:%s over %s period(s). The period break(s) will take %s:%s." % (match_minutes, match_seconds, periods, match_break_minutes, match_break_seconds)

	myPlayerList = playerlib.getPlayerList("#human")
	for ply in myPlayerList:
		cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
		es.server.queuecmd(cmd)

	freeze_match()

	es.doblock("soccer_mod_2010/match/stats/score_sheet/reset")

	value = es.ServerVar("sm_match_restart_length")
	cmd = "mp_restartgame %s" % (value)
	es.server.queuecmd(cmd)

def freeze_match():
	myPlayerList = playerlib.getPlayerList("#alive")
	for ply in myPlayerList:
		ply.freeze(1)

	cmd = "phys_pushscale 1"
	es.server.queuecmd(cmd)

	cmd = "phys_timescale 0"
	es.server.queuecmd(cmd)

def cmd_match_stop():
	userid = es.getcmduserid()

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("sm_match_say_command_stop_match_on")
		if check == 1:
			stop_match(userid)
		else:
			es.tell(userid, "#green", "Stop match command is turned off.")
	else:
		es.tell(userid, "#green", "Soccer Mod is not allowed on this map.")

def popup_match_stop(userid, choice, popupid):
	stop_match(userid)
	popuplib.send("sm_popup_admin_match", userid)

def stop_match(userid):
	check = es.ServerVar("match")
	if check == 1:
		es.set("match", 0)
		es.set("match_paused", 0)
		es.set("period_running", 0)
		es.set("period_break_running", 0)
		es.set("golden_goal", 0)
		es.set("seconds", 0)
		es.set("minutes", 0)
		es.set("period_break_running", 0)

		unfreeze_match()

		name = es.getplayername(userid)
		message = "%s has stopped the match." % (name)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "No match started.")
		
def unfreeze_match():
	myPlayerList = playerlib.getPlayerList("#alive")
	for ply in myPlayerList:
		ply.freeze(0)

	cmd = "phys_pushscale 900"
	es.server.queuecmd(cmd)

	cmd = "phys_timescale 1"
	es.server.queuecmd(cmd)

def cmd_match_pause():
	userid = es.getcmduserid()

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("sm_match_say_command_pause_match_on")
		if check == 1:
			pause_match(userid)
		else:
			es.tell(userid, "#green", "Pause match command is turned off.")
	else:
		es.tell(userid, "#green", "Soccer Mod is not allowed on this map.")

def popup_match_pause(userid, choice, popupid):
	pause_match(userid)
	popuplib.send("sm_popup_admin_match", userid)

def pause_match(userid):
	check = es.ServerVar("match")
	if check == 1:
		check = es.ServerVar("match_paused")
		if check == 0:
			es.set("match_paused", 1)

			freeze_match()

			name = es.getplayername(userid)
			message = "%s has paused the match." % (name)
			es.msg("#green", message)
		else:
			es.tell(userid, "#green", "Match already paused.")
	else:
		es.tell(userid, "#green", "No match started.")

def cmd_match_unpause():
	userid = es.getcmduserid()

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("sm_match_say_command_pause_match_on")
		if check == 1:
			unpause_match(userid)
		else:
			es.tell(userid, "#green", "Unpause match command is turned off.")
	else:
		es.tell(userid, "#green", "Soccer Mod is not allowed on this map.")

def popup_match_unpause(userid, choice, popupid):
	unpause_match(userid)
	popuplib.send("sm_popup_admin_match", userid)

def unpause_match(userid):
	check = es.ServerVar("match")
	if check == 1:
		check = es.ServerVar("match_paused")
		if check == 1:
			check = es.ServerVar("period_break_running")
			if check == 0:
				check = es.ServerVar("match_paused_delay")
				if check == 0:
					es.set("match_paused_delay", 1)

					show_centermsg("| GET READY! |")
					gamethread.delayed(1, show_centermsg, ("| 5 |"))
					gamethread.delayed(2, show_centermsg, ("| 4 |"))
					gamethread.delayed(3, show_centermsg, ("| 3 |"))
					gamethread.delayed(4, show_centermsg, ("| 2 |"))
					gamethread.delayed(5, show_centermsg, ("| 1 |"))
					gamethread.delayed(6, show_centermsg, ("| GO! |"))

					gamethread.delayed(6, unfreeze_match)

					gamethread.delayed(6, set_cvar, ("match_paused_delay", 0))
					gamethread.delayed(6, set_cvar, ("match_paused", 0))

					name = es.getplayername(userid)
					message = "%s has unpaused the match." % (name)
					es.msg("#green", message)
			else:
				es.set("match_paused_delay", 0)
				es.set("match_paused", 0)

				unfreeze_match()

				name = es.getplayername(userid)
				message = "%s has unpaused the match." % (name)
				es.msg("#green", message)
		else:
			es.tell(userid, "#green", "Match already unpaused.")
	else:
		es.tell(userid, "#green", "No match started.")

def show_centermsg(message):
	es.centermsg(message)

def set_cvar(name, value):
	es.set(name, value)

def delete_popup():
	if popuplib.exists("sm_popup_admin_match"):
		popuplib.delete("sm_popup_admin_match")

def unload():
	delete_popup()

	es.unload("soccer_mod_2010/match/names")
	es.unload("soccer_mod_2010/match/score")
	es.unload("soccer_mod_2010/match/time")

	check = es.ServerVar("sm_module_match_stats_on")
	if check == 1:
		es.unload("soccer_mod_2010/match/stats")