import es
import langlib
import popuplib

def load():
	create_popup()
	load_variables()

def load_variables():
	es.set("sm_match_score_t", 0)
	es.set("sm_match_score_ct", 0)

def es_map_start(event_var):
	load_variables()

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		score_t = es.ServerVar("sm_match_score_t")
		cmd = "score set #t %s" % (score_t)
		es.server.queuecmd(cmd)

		score_ct = es.ServerVar("sm_match_score_ct")
		cmd = "score set #ct %s" % (score_ct)
		es.server.queuecmd(cmd)

def round_end(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		name_t = es.ServerVar("sm_match_name_t")
		name_ct = es.ServerVar("sm_match_name_ct")

		name_t_abbr = es.ServerVar("sm_match_name_t_abbr")
		name_ct_abbr = es.ServerVar("sm_match_name_ct_abbr")

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		swap = es.ServerVar("sm_match_swap_home_away_on")
		seconds = es.ServerVar("sm_match_seconds")
		minutes = es.ServerVar("sm_match_minutes")

		if event_var["winner"] == "1":
			check = es.ServerVar("match")
			if check == 1:
				load_variables()

		if event_var["winner"] == "2":
			score_t += 1
			es.set("sm_match_score_t", score_t)

			check = es.ServerVar("match")
			if check == 1:
				if swap == 0:
					if seconds < 10:
						message = "After %s:0%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_t, name_t_abbr, score_t, score_ct, name_ct_abbr)
					else:
						message = "After %s:%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_t, name_t_abbr, score_t, score_ct, name_ct_abbr)
				else:
					if seconds < 10:
						message = "After %s:0%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_t, name_ct_abbr, score_ct, score_t, name_t_abbr)
					else:
						message = "After %s:%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_t, name_ct_abbr, score_ct, score_t, name_t_abbr)
			else:
				swap = es.ServerVar("sm_match_swap_home_away_on")
				if swap == 0:
					message = "%s has scored a goal: %s %s - %s %s." % (name_t, name_t_abbr, score_t, score_ct, name_ct_abbr)
				else:
					message = "%s has scored a goal: %s %s - %s %s." % (name_t, name_ct_abbr, score_ct, score_t, name_t_abbr)

			es.msg("#green", message)

			check = es.ServerVar("golden_goal")
			if check == 1:
				es.doblock("soccer_mod_2010/match/time/win_t")

		if event_var["winner"] == "3":
			score_ct += 1
			es.set("sm_match_score_ct", score_ct)

			check = es.ServerVar("match")
			if check == 1:
				if swap == 0:
					if seconds < 10:
						message = "After %s:0%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_ct, name_t_abbr, score_t, score_ct, name_ct_abbr)
					else:
						message = "After %s:%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_ct, name_t_abbr, score_t, score_ct, name_ct_abbr)
				else:
					if seconds < 10:
						message = "After %s:0%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_ct, name_ct_abbr, score_ct, score_t, name_t_abbr)
					else:
						message = "After %s:%s of play %s has scored a goal: %s %s - %s %s." % (minutes, seconds, name_ct, name_ct_abbr, score_ct, score_t, name_t_abbr)
			else:
				swap = es.ServerVar("sm_match_swap_home_away_on")
				if swap == 0:
					message = "%s has scored a goal: %s %s - %s %s." % (name_ct, name_t_abbr, score_t, score_ct, name_ct_abbr)
				else:
					message = "%s has scored a goal: %s %s - %s %s." % (name_ct, name_ct_abbr, score_ct, score_t, name_t_abbr)

			es.msg("#green", message)

			check = es.ServerVar("golden_goal")
			if check == 1:
				es.doblock("soccer_mod_2010/match/time/win_ct")

		check = es.ServerVar("golden_goal")
		if check == 1:
			es.set("match", 0)
			es.set("match_paused", 0)
			es.set("period_running", 0)
			es.set("period_break_running", 0)
			es.set("golden_goal", 0)
			es.set("seconds", 0)
			es.set("minutes", 0)
			es.set("period_break_running", 0)

		cmd = "score set #t %s" % (score_t)
		es.server.queuecmd(cmd)

		cmd = "score set #ct %s" % (score_ct)
		es.server.queuecmd(cmd)

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_admin_match_score.ini")

	popup = popuplib.create("sm_popup_admin_match_score")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_match_name_t")
	tokens = {}
	tokens['team'] = value
	line = "->1. %s" % (text("add", tokens))
	popup.addline(line)

	value = es.ServerVar("sm_match_name_t")
	tokens = {}
	tokens['team'] = value
	line = "->2. %s" % (text("remove", tokens))
	popup.addline(line)

	value = es.ServerVar("sm_match_name_ct")
	tokens = {}
	tokens['team'] = value
	line = "->3. %s" % (text("add", tokens))
	popup.addline(line)

	value = es.ServerVar("sm_match_name_ct")
	tokens = {}
	tokens['team'] = value
	line = "->4. %s" % (text("remove", tokens))
	popup.addline(line)

	line = "->5. %s" % (text("reset"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, add_t)
	popup.select(2, remove_t)
	popup.select(3, add_ct)
	popup.select(4, remove_ct)
	popup.select(5, reset_score)
	popup.submenu(6, "sm_popup_admin_match_score")
	popup.submenu(7, "sm_popup_admin_match_score")
	popup.submenu(8, "sm_popup_admin_match_score")
	popup.submenu(9, "sm_popup_admin_match")

def add_t(userid, choice, popupid):
	score = es.ServerVar("sm_match_score_t")
	score += 1
	es.set("sm_match_score_t", score)

	cmd = "score set #t %s" % (score)
	es.server.queuecmd(cmd)

	name = es.getplayername(userid)
	team = es.ServerVar("sm_match_name_t")
	message = "%s has added 1 goal to %s." % (name, team)
	es.msg("#green", message)

	popuplib.send("sm_popup_admin_match_score", userid)

def remove_t(userid, choice, popupid):
	score = es.ServerVar("sm_match_score_t")
	if score > 0:
		score -= 1
		es.set("sm_match_score_t", score)

		cmd = "score set #t %s" % (score)
		es.server.queuecmd(cmd)

		name = es.getplayername(userid)
		team = es.ServerVar("sm_match_name_t")
		message = "%s has removed 1 goal from %s." % (name, team)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "Score is already 0.")

	popuplib.send("sm_popup_admin_match_score", userid)

def add_ct(userid, choice, popupid):
	score = es.ServerVar("sm_match_score_ct")
	score += 1
	es.set("sm_match_score_ct", score)

	cmd = "score set #ct %s" % (score)
	es.server.queuecmd(cmd)

	name = es.getplayername(userid)
	team = es.ServerVar("sm_match_name_ct")
	message = "%s has added 1 goal to %s." % (name, team)
	es.msg("#green", message)

	popuplib.send("sm_popup_admin_match_score", userid)

def remove_ct(userid, choice, popupid):
	score = es.ServerVar("sm_match_score_ct")
	if score > 0:
		score -= 1
		es.set("sm_match_score_ct", score)

		cmd = "score set #ct %s" % (score)
		es.server.queuecmd(cmd)

		name = es.getplayername(userid)
		team = es.ServerVar("sm_match_name_ct")
		message = "%s has removed 1 goal from %s." % (name, team)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "Score is already 0.")

	popuplib.send("sm_popup_admin_match_score", userid)

def reset_score(userid, choice, popupid):
	load_variables()

	cmd = "score set #t 0"
	es.server.queuecmd(cmd)

	cmd = "score set #ct 0"
	es.server.queuecmd(cmd)

	name = es.getplayername(userid)
	message = "%s has reset the score." % (name)
	es.msg("#green", message)

	popuplib.send("sm_popup_admin_match_score", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_match_score"):
		popuplib.delete("sm_popup_admin_match_score")

def unload():
	delete_popup()