import es
import math
import popuplib

score_sheet = []

def load():
	reset()

def es_map_start(event_var):
	reset()

def reset():
	es.set("sm_stats_score_sheet_number", 1)
	global score_sheet
	score_sheet = []

def add():
	check = es.ServerVar("match")
	if check == 1:
		minutes = es.ServerVar("sm_match_minutes")
		seconds = es.ServerVar("sm_match_seconds")

		if seconds < 10:
			line = "%s:0%s " % (minutes, seconds)
		else:
			line = "%s:%s " % (minutes, seconds)

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		check = es.ServerVar("sm_match_swap_home_away_on")
		if check == 0:
			line += "%s - %s " % (score_t, score_ct)
		else:
			line += "%s - %s " % (score_ct, score_t)

		team = es.ServerVar("sm_stats_shooter_team")
		name = es.ServerVar("sm_stats_shooter_name")

		line += name
		line += " "

		winner = int(es.ServerVar("sm_stats_winner"))
		assister_team = es.ServerVar("sm_stats_assister_team")
		assister_name = es.ServerVar("sm_stats_assister_name")

		if team == winner:
			if assister_team == winner:
				line += "(%s)" % (assister_name)
			else:
				line += "(No Assist)"
		else:
			line += "(Own Goal)"

		number = es.ServerVar("sm_stats_score_sheet_number")

		score_sheet.insert(number, line)

		number += 1
		es.set("sm_stats_score_sheet_number", number)

		delete_popup()
		create_popup()

def create_popup():
	number = 1
	page = 1
	result = 1
	length = float(len(score_sheet))
	number_pages = int(math.ceil(length / 5))

	popup = popuplib.create("sm_popup_stats_score_sheet_1")
	line = "SOCCER MOD STATS SCORE SHEET (1/%s)" % (number_pages)
	popup.addline(line)
	popup.addline(" ")

	for row in score_sheet:
		popup.addline(row)

		number += 1
		result += 1

		if number > 5 or result > length:
			number = 1

			if length > 5:
				popup.addline(" ")

			page -= 1
			if page > 0:
				popup.addline("->8. Back")
				line = "sm_popup_stats_score_sheet_%s" % (page)
				popup.submenu(8, line)

			page += 2
			if page <= number_pages:
				popup.addline("->9. Next")
				line = "sm_popup_stats_score_sheet_%s" % (page)
				popup.submenu(9, line)

			popup.addline(" ")
			popup.addline("0. Cancel")
			popup.submenu(10, "sm_popup_stats")

			if result <= length:
				line = "sm_popup_stats_score_sheet_%s" % (page)
				popup = popuplib.create(line)
				line = "SOCCER MOD STATS SCORE SHEET (%s/%s)" % (page, number_pages)
				popup.addline(line)
				popup.addline(" ")

def delete_popup():
	number = 1
	exists = 1
	while exists == 1:
		name = "sm_popup_stats_score_sheet_%s" % (number)
		if popuplib.exists(name):
			popuplib.delete(name)
		else:
			exists = 0
		number += 1

def unload():
	delete_popup()