import es
import gamethread
import math
import playerlib
import popuplib
import random

def load():
	create_popups()

def create_popups():
	popup = popuplib.create("sm_popup_match_win")
	popup.addline("SOCCER MOD MATCH WIN")
	popup.addline(" ")
	popup.addline("Do you want a beer to celibrate?")
	popup.addline(" ")
	popup.addline("->1. Yes")
	popup.addline("->2. No")
	popup.addline(" ")
	popup.addline("0. Close")
	popup.select(1, beer)
	popup.select(3, no_choice_win)
	popup.select(4, no_choice_win)
	popup.select(5, no_choice_win)
	popup.select(6, no_choice_win)
	popup.select(7, no_choice_win)
	popup.select(8, no_choice_win)
	popup.select(9, no_choice_win)

	popup = popuplib.create("sm_popup_match_lose")
	popup.addline("SOCCER MOD MATCH LOSE")
	popup.addline(" ")
	popup.addline("Do you want to end it all?")
	popup.addline(" ")
	popup.addline("->1. Yes")
	popup.addline("->2. No")
	popup.addline(" ")
	popup.addline("0. Close")
	popup.select(1, fireworks)
	popup.select(3, no_choice_lose)
	popup.select(4, no_choice_lose)
	popup.select(5, no_choice_lose)
	popup.select(6, no_choice_lose)
	popup.select(7, no_choice_lose)
	popup.select(8, no_choice_lose)
	popup.select(9, no_choice_lose)

def beer(userid, choice, popupid):
	es.centertell(userid, "Enjoy your beer!")
	#cmd = "est_drunk %s 10" % (userid)
	#es.server.queuecmd(cmd)

def no_choice_win(userid, choice, popupid):
	popuplib.send("sm_popup_match_win", userid)

def fireworks(userid, choice, popupid):
	es.centertell(userid, "Fireworks!")

	sound = es.ServerVar("sm_referee_sound_fireworks")
	es.emitsound("player", userid, sound, "1.0", "0.5")

	#cmd = "est_shake %s 2 100 1" % (userid)
	#es.server.queuecmd(cmd)

	push_player(userid, 5)
	gamethread.delayed(0.1, push_player, (userid, 20))
	gamethread.delayed(0.2, push_player, (userid, 45))
	gamethread.delayed(0.3, push_player, (userid, 80))
	gamethread.delayed(0.4, push_player, (userid, 125))
	gamethread.delayed(0.5, push_player, (userid, 180))
	gamethread.delayed(0.6, push_player, (userid, 245))
	gamethread.delayed(0.7, push_player, (userid, 320))
	gamethread.delayed(0.8, push_player, (userid, 405))
	gamethread.delayed(0.9, push_player, (userid, 500))
	gamethread.delayed(1, push_player, (userid, 605))
	gamethread.delayed(1.1, push_player, (userid, 720))
	gamethread.delayed(1.2, push_player, (userid, 845))
	gamethread.delayed(1.3, push_player, (userid, 980))
	gamethread.delayed(1.4, push_player, (userid, 1125))
	gamethread.delayed(1.5, push_player, (userid, 1280))
	gamethread.delayed(1.6, push_player, (userid, 1445))
	gamethread.delayed(1.7, push_player, (userid, 1620))
	gamethread.delayed(1.8, push_player, (userid, 1805))
	gamethread.delayed(1.9, push_player, (userid, 2000))

	gamethread.delayed(2.5, explosion, (userid))
	gamethread.delayed(2.5, kill_player, (userid))

def push_player(userid, push):
	myPlayer = playerlib.getPlayer(userid)
	isdead = myPlayer.isdead
	if isdead == 0:
		prop = "0,0,%s" % (push)
		es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", prop)

def explosion(userid):
	myPlayer = playerlib.getPlayer(userid)
	isdead = myPlayer.isdead
	if isdead == 0:
		es.emitsound("player", userid, "weapons/hegrenade/explode4.wav", "1.0", "0.5")
		x,y,z = es.getplayerlocation(userid)
		pos1 = "%s,%s,%s" % (x, y, z)
		pos2 = "0,0,0"
		cmd = "es_xeffect sparks %s 9999 3 %s" % (pos1, pos2)
		es.server.queuecmd(cmd)

def kill_player(userid):
	es.sexec(userid, "kill")

def no_choice_lose(userid, choice, popupid):
	popuplib.send("sm_popup_match_lose", userid)

def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("match")
		if check == 1:
			period_break_running = es.ServerVar("period_break_running")
			match_paused = int(es.ServerVar("match_paused"))
			if period_break_running == 1 or match_paused == 1:
				player = playerlib.getPlayer(event_var["userid"])
				player.freeze(1)

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("match")
		if check == 1:
			period = es.ServerVar("period")
			sm_match_number_periods = int(es.ServerVar("sm_match_number_periods"))
			if period <= sm_match_number_periods:
				check = es.ServerVar("period_running")
				if check == 0:
					check = es.ServerVar("period_break_running")
					if check == 0:
						period_timer(0)

						even = period % 2

						if even == 1:
							team = es.ServerVar("sm_match_name_t")
							message = "%s has kick off." % (team)
						else:
							team = es.ServerVar("sm_match_name_ct")
							message = "%s has kick off." % (team)

						es.msg("#green", message)
						es.centermsg(message)

			check = es.ServerVar("golden_goal")
			if check == 1:
				golden_goal_timer(0)

				number = random.randint(0, 1)

				if number == 1:
					team = es.ServerVar("sm_match_name_t")
					message = "%s has kick off." % (team)
				else:
					team = es.ServerVar("sm_match_name_ct")
					message = "%s has kick off." % (team)

				es.msg("#green", message)
				es.centermsg(message)

def period_timer(time):
	check = es.ServerVar("match")
	if check == 1:
		period = es.ServerVar("period")
		period_length = int(es.ServerVar("sm_match_period_length"))
		time_add = (period - 1) * period_length
		time += time_add

		minutes = int(math.floor(time / 60))
		es.set("sm_match_minutes", minutes)

		seconds = int(time - (minutes * 60))
		es.set("sm_match_seconds", seconds)

		time -= time_add

		score_t = int(es.ServerVar("sm_match_score_t"))
		score_ct = int(es.ServerVar("sm_match_score_ct"))

		name_t = es.ServerVar("sm_match_name_t_abbr")
		name_ct = es.ServerVar("sm_match_name_ct_abbr")

		check = es.ServerVar("sm_match_score_board_on")
		if check == 1:
			check = es.ServerVar("sm_match_swap_home_away_on")
			if check == 0:
				if seconds < 10:
					message = "%s:0%s | %s %s - %s %s" % (minutes, seconds, name_t, score_t, score_ct, name_ct)
				else:
					message = "%s:%s | %s %s - %s %s" % (minutes, seconds, name_t, score_t, score_ct, name_ct)
			else:
				if seconds < 10:
					message = "%s:0%s | %s %s - %s %s" % (minutes, seconds, name_ct, score_ct, score_t, name_t)
				else:
					message = "%s:%s | %s %s - %s %s" % (minutes, seconds, name_ct, score_ct, score_t, name_t)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
				es.server.queuecmd(cmd)

			source_tv = es.ServerVar("tv_name")
			source_tv_id = es.getuserid(source_tv)

			source_tv_on = es.ServerVar("tv_enable")
			if source_tv_on == 1:
				es.menu(1, source_tv_id, message)

		check = es.ServerVar("match_paused")
		if check == 0:
			check = es.ServerVar("sm_match_first_hit")
			if check == 0:
				time += 1

		if time <= period_length:
			es.set("period_running", 1)
			es.set("period_break_running", 0)
			gamethread.delayed(1, period_timer, (time))
		else:
			period += 1
			es.set("period", period)

			es.set("period_running", 0)
			es.set("period_break_running", 0)

			periods = int(es.ServerVar("sm_match_number_periods"))
			if period <= periods:
				break_length = int(es.ServerVar("sm_match_period_break_length"))
				freeze_match()
				period_break_timer(break_length)

				check = es.ServerVar("sm_match_sounds_on")
				if check == 1:
					sound = es.ServerVar("sm_match_sound_period_end")
					es.cexec_all("playgamesound", sound)

			else:
				if score_t > score_ct:
					win_t()
				elif score_t < score_ct:
					win_ct()
				elif score_t == score_ct:
					draw()

def freeze_match():
	myPlayerList = playerlib.getPlayerList("#alive")
	for ply in myPlayerList:
		ply.freeze(1)

	cmd = "phys_pushscale 1"
	es.server.queuecmd(cmd)

	cmd = "phys_timescale 0"
	es.server.queuecmd(cmd)

def period_break_timer(time):
	check = es.ServerVar("match")
	if check == 1:
		minutes = int(math.floor(time / 60))
		seconds = int(time - (minutes * 60))

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		name_t = es.ServerVar("sm_match_name_t_abbr")
		name_ct = es.ServerVar("sm_match_name_ct_abbr")

		check = es.ServerVar("sm_match_score_board_on")
		if check == 1:
			score_board = es.ServerVar("score_board_period")
			check = es.ServerVar("sm_match_swap_home_away_on")
			if check == 0:
				if seconds < 10:
					message = "%s: %s:0%s | %s %s - %s %s" % (score_board, minutes, seconds, name_t, score_t, score_ct, name_ct)
				else:
					message = "%s: %s:%s | %s %s - %s %s" % (score_board, minutes, seconds, name_t, score_t, score_ct, name_ct)
			else:
				if seconds < 10:
					message = "%s: %s:0%s | %s %s - %s %s" % (score_board, minutes, seconds, name_ct, score_ct, score_t, name_t)
				else:
					message = "%s: %s:%s | %s %s - %s %s" % (score_board, minutes, seconds, name_ct, score_ct, score_t, name_t)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
				es.server.queuecmd(cmd)

			source_tv = es.ServerVar("tv_name")
			source_tv_id = es.getuserid(source_tv)

			source_tv_on = es.ServerVar("tv_enable")
			if source_tv_on == 1:
				es.menu(1, source_tv_id, message)

		check = es.ServerVar("match_paused")
		if check == 0:
			time -= 1

		if time > 0:
			es.set("period_running", 0)
			es.set("period_break_running", 1)
			gamethread.delayed(1, period_break_timer, (time))
		else:
			es.set("period_running", 0)
			es.set("period_break_running", 0)
			es.set("sm_match_first_hit", 1)
			cmd = "mp_restartgame 1"
			es.server.queuecmd(cmd)

def golden_goal_timer(time):
	check = es.ServerVar("match")
	if check == 1:
		check = es.ServerVar("golden_goal")
		if check == 1:
			period = es.ServerVar("period")
			period_length = int(es.ServerVar("sm_match_period_length"))
			time_add = (period - 1) * period_length
			time += time_add

			minutes = int(math.floor(time / 60))
			es.set("sm_match_minutes", minutes)

			seconds = int(time - (minutes * 60))
			es.set("sm_match_seconds", seconds)

			time -= time_add

			score_t = es.ServerVar("sm_match_score_t")
			score_ct = es.ServerVar("sm_match_score_ct")

			name_t = es.ServerVar("sm_match_name_t_abbr")
			name_ct = es.ServerVar("sm_match_name_ct_abbr")

			check = es.ServerVar("sm_match_score_board_on")
			if check == 1:
				check = es.ServerVar("sm_match_swap_home_away_on")
				if check == 0:
					if seconds < 10:
						message = "Golden goal: %s:0%s | %s %s - %s %s" % (minutes, seconds, name_t, score_t, score_ct, name_ct)
					else:
						message = "Golden goal: %s:%s | %s %s - %s %s" % (minutes, seconds, name_t, score_t, score_ct, name_ct)
				else:
					if seconds < 10:
						message = "Golden goal: %s:0%s | %s %s - %s %s" % (minutes, seconds, name_ct, score_ct, score_t, name_t)
					else:
						message = "Golden goal: %s:%s | %s %s - %s %s" % (minutes, seconds, name_ct, score_ct, score_t, name_t)

				myPlayerList = playerlib.getPlayerList("#human")
				for ply in myPlayerList:
					cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
					es.server.queuecmd(cmd)

				source_tv = es.ServerVar("tv_name")
				source_tv_id = es.getuserid(source_tv)

				source_tv_on = es.ServerVar("tv_enable")
				if source_tv_on == 1:
					es.menu(1, source_tv_id, message)

			check = es.ServerVar("match_paused")
			if check == 0:
				check = es.ServerVar("sm_match_first_hit")
				if check == 0:
					time += 1

			gamethread.delayed(1, golden_goal_timer, (time))

def win_t():
	es.set("match", 0)
	es.set("match_paused", 0)
	es.set("period_running", 0)
	es.set("period_break_running", 0)
	es.set("golden_goal", 0)
	es.set("seconds", 0)
	es.set("minutes", 0)
	es.set("period_break_running", 0)

	score_t = es.ServerVar("sm_match_score_t")
	score_ct = es.ServerVar("sm_match_score_ct")

	name_t = es.ServerVar("sm_match_name_t_abbr")
	name_ct = es.ServerVar("sm_match_name_ct_abbr")

	check = es.ServerVar("sm_match_sounds_on")
	if check == 1:
		sound = es.ServerVar("sm_match_sound_match_end")
		es.cexec_all("playgamesound", sound)

	myPlayerList = playerlib.getPlayerList("#t")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_win", player.userid)

	myPlayerList = playerlib.getPlayerList("#ct")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_lose", player.userid)

	check = es.ServerVar("sm_match_swap_home_away_on")
	if check == 0:
		message = "Final score: %s %s - %s %s." % (name_t, score_t, score_ct, name_ct)
	else:
		message = "Final score: %s %s - %s %s." % (name_ct, score_ct, score_t, name_t)
	es.msg("#green", message)

def win_ct():
	es.set("match", 0)
	es.set("match_paused", 0)
	es.set("period_running", 0)
	es.set("period_break_running", 0)
	es.set("golden_goal", 0)
	es.set("seconds", 0)
	es.set("minutes", 0)
	es.set("period_break_running", 0)

	score_t = es.ServerVar("sm_match_score_t")
	score_ct = es.ServerVar("sm_match_score_ct")

	name_t = es.ServerVar("sm_match_name_t_abbr")
	name_ct = es.ServerVar("sm_match_name_ct_abbr")

	check = es.ServerVar("sm_match_sounds_on")
	if check == 1:
		sound = es.ServerVar("sm_match_sound_match_end")
		es.cexec_all("playgamesound", sound)

	myPlayerList = playerlib.getPlayerList("#t")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_lose", player.userid)

	myPlayerList = playerlib.getPlayerList("#ct")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_win", player.userid)

	check = es.ServerVar("sm_match_swap_home_away_on")
	if check == 0:
		message = "Final score: %s %s - %s %s." % (name_t, score_t, score_ct, name_ct)
	else:
		message = "Final score: %s %s - %s %s." % (name_ct, score_ct, score_t, name_t)
	es.msg("#green", message)

def draw():
	check = es.ServerVar("sm_match_golden_goal_on")
	if check == 1:
		es.set("golden_goal", 1)

		freeze_match()

		check = es.ServerVar("sm_match_sounds_on")
		if check == 1:
			sound = es.ServerVar("sm_match_sound_period_end")
			es.cexec_all("playgamesound", sound)

		es.msg("#green", "The match ended in a draw and will continue with a golden goal.")

		es.set("sm_match_first_hit", 1)

		value = es.ServerVar("sm_match_restart_length")
		cmd = "mp_restartgame %s" % (value)
		es.server.queuecmd(cmd)
	else:
		es.set("match", 0)
		es.set("match_paused", 0)
		es.set("period_running", 0)
		es.set("period_break_running", 0)
		es.set("golden_goal", 0)
		es.set("seconds", 0)
		es.set("minutes", 0)
		es.set("period_break_running", 0)

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		name_t = es.ServerVar("sm_match_name_t_abbr")
		name_ct = es.ServerVar("sm_match_name_ct_abbr")

		check = es.ServerVar("sm_match_sounds_on")
		if check == 1:
			sound = es.ServerVar("sm_match_sound_match_end")
			es.cexec_all("playgamesound", sound)

		check = es.ServerVar("sm_match_swap_home_away_on")
		if check == 0:
			message = "Final score: %s %s - %s %s." % (name_t, score_t, score_ct, name_ct)
		else:
			message = "Final score: %s %s - %s %s." % (name_ct, score_ct, score_t, name_t)
		es.msg("#green", message)

def delete_popups():
	if popuplib.exists("sm_popup_match_win"):
		popuplib.delete("sm_popup_match_win")

	if popuplib.exists("sm_popup_match_lose"):
		popuplib.delete("sm_popup_match_lose")

def unload():
	delete_popups()